package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.domain.CourseEducationType;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.course.bo.CourseHandoutsBusinessAddBo;
import com.zhongzheng.modules.course.bo.CourseHandoutsBusinessQueryBo;
import com.zhongzheng.modules.course.bo.CourseHandoutsBusinessEditBo;
import com.zhongzheng.modules.course.domain.CourseHandoutsBusiness;
import com.zhongzheng.modules.course.mapper.CourseHandoutsBusinessMapper;
import com.zhongzheng.modules.course.vo.CourseHandoutsBusinessVo;
import com.zhongzheng.modules.course.service.ICourseHandoutsBusinessService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 讲义关联业务Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-02
 */
@Service
public class CourseHandoutsBusinessServiceImpl extends ServiceImpl<CourseHandoutsBusinessMapper, CourseHandoutsBusiness> implements ICourseHandoutsBusinessService {

    @Override
    public CourseHandoutsBusinessVo queryById(Long id){
        CourseHandoutsBusiness db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, CourseHandoutsBusinessVo.class);
    }

    @Override
    public List<CourseHandoutsBusinessVo> queryList(CourseHandoutsBusinessQueryBo bo) {
        LambdaQueryWrapper<CourseHandoutsBusiness> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getEducationId() != null, CourseHandoutsBusiness::getEducationId, bo.getEducationId());
        lqw.eq(bo.getBusinessId() != null, CourseHandoutsBusiness::getBusinessId, bo.getBusinessId());
        lqw.eq(bo.getHandoutsId() != null, CourseHandoutsBusiness::getHandoutsId, bo.getHandoutsId());
        lqw.orderByDesc(CourseHandoutsBusiness::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<CourseHandoutsBusinessVo> entity2Vo(Collection<CourseHandoutsBusiness> collection) {
        List<CourseHandoutsBusinessVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, CourseHandoutsBusinessVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<CourseHandoutsBusiness> page = (Page<CourseHandoutsBusiness>)collection;
            Page<CourseHandoutsBusinessVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(CourseHandoutsBusinessAddBo bo) {
        CourseHandoutsBusiness add = BeanUtil.toBean(bo, CourseHandoutsBusiness.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(CourseHandoutsBusinessEditBo bo) {
        CourseHandoutsBusiness update = BeanUtil.toBean(bo, CourseHandoutsBusiness.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(CourseHandoutsBusiness entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
